---
title: WebGL2RenderingContext.readBuffer()
slug: Web/API/WebGL2RenderingContext/readBuffer
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.readBuffer()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> selects a color buffer as the source for pixels for subsequent calls to {{domxref("WebGLRenderingContext.copyTexImage2D", "copyTexImage2D")}}, {{domxref("WebGLRenderingContext.copyTexSubImage2D", "copyTexSubImage2D")}}, {{domxref("WebGL2RenderingContext.copyTexSubImage3D", "copyTexSubImage3D")}} or {{domxref("WebGLRenderingContext.readPixels", "readPixels")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.readBuffer(<var>src</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>src</code></dt>
 <dd>A {{domxref("GLenum")}} specifying a color buffer. Possible values:
 <ul>
  <li><code>gl.BACK</code>: Reads from the back color buffer.</li>
  <li><code>gl.NONE</code>: Reads from no color buffer.</li>
  <li><code>gl.COLOR_ATTACHMENT{0-15}</code>: Reads from one of the 16 color attachment buffers.</li>
 </ul>
 </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.readBuffer(gl.COLOR_ATTACHMENT0);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.4", "readBuffer")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glReadBuffer.xhtml", "glReadBuffer")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.readBuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.copyTexImage2D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.copyTexSubImage2D()")}}</li>
 <li>{{domxref("WebGL2RenderingContext.copyTexSubImage3D()")}}</li>
 <li>{{domxref("WebGLRenderingContext.readPixels()")}}</li>
</ul>
